/*
 Copyright (c) Information Equipment co.,LTD.
 All right reserved.
 
 Code by JaeHyuk Cho <mailto:minzkn@infoeq.com> Made in KOREA

 http://minzkn.pe.ky
*/

#ifndef DEF_SOURCE_dsp_c 
#define DEF_SOURCE_dsp_c "dsp.c"

#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>

#include "mz.h"

static int __MZ_DSP_Setup__(int s_Handle, int s_Control, int s_Value);

int MZ_DSP_SetupFormat(int s_Handle, int s_Format);
int MZ_DSP_SetupChannels(int s_Handle, int s_Channels);
int MZ_DSP_SetupFrequency(int s_Handle, int s_Frequency);

/* [ Static function ] ==================================================================== */
static int __MZ_DSP_Setup__(int s_Handle, int s_Control, int s_Value)
{
 int s_Return;
 if(s_Handle >= 0)
 { 
  if(ioctl(s_Handle, s_Control, &s_Value) == 0)s_Return = 1;
  else s_Return = (-1);
 }
 else s_Return = (-1);
 return(s_Return);
}

/* [ Public function ] ==================================================================== */
int MZ_DSP_SetupFormat(int s_Handle, int s_Format)
{
 return(__MZ_DSP_Setup__(s_Handle, SNDCTL_DSP_SETFMT, s_Format));
}

int MZ_DSP_SetupChannels(int s_Handle, int s_Channels)
{
 return(__MZ_DSP_Setup__(s_Handle, SNDCTL_DSP_CHANNELS, s_Channels));
}

int MZ_DSP_SetupFrequency(int s_Handle, int s_Frequency)
{
 return(__MZ_DSP_Setup__(s_Handle, SNDCTL_DSP_SPEED, s_Frequency));
}

#endif

/* End of source */
