/*
 Copyright (c) Information Equipment co.,LTD.
 All right reserved.
 
 Code by JaeHyuk Cho <mailto:minzkn@infoeq.com> Made in KOREA

 http://minzkn.pe.ky
*/

#ifndef DEF_SOURCE_screen_c 
#define DEF_SOURCE_screen_c "screen.c"

#ifndef DEF_STANDALONE
#define DEF_STANDALONE (0)
#endif

#include <stdio.h>

#if DEF_STANDALONE == (0)
#include "mz.h"
#endif

void MZ_SCREEN_Clear(void);
void MZ_SCREEN_MoveCursor(int s_x, int s_y);

/* [ Static function ] ==================================================================== */

/* [ Public function ] ==================================================================== */
void MZ_SCREEN_Clear(void)
{
 fprintf(stdout, "\x1b[2J"); 
 fflush(stdout);
}

void MZ_SCREEN_MoveCursor(int s_x, int s_y)
{
 fprintf(stdout, "\x1b[%d;%dH", s_x, s_y);
 fflush(stdout);
}

#if DEF_STANDALONE == (1)
int main(void)
{
 MZ_SCREEN_Clear();
 MZ_SCREEN_MoveCursor(0, 0);
 return(0);
}
#endif

#endif

/* End of source */
