/*
 Copyright (c) Information Equipment co.,LTD.
 All right reserved.
 
 Code by JaeHyuk Cho <mailto:minzkn@infoeq.com> Made in KOREA

 http://minzkn.pe.ky

 libmz test code
*/

#ifndef DEF_SOURCE_test_c 
#define DEF_SOURCE_test_c "test.c"

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <wait.h>
#include <arpa/inet.h>

#include "mz.h"

int main(int s_Argc, char *s_Argv[]);

int main(int s_Argc, char *s_Argv[])
{
 int s_Return = 0;
#if 1
 fprintf(stdout, "libmz.* release %s - Copyright(c)MINZ team - %s %s\n", MZ_ReleaseString(), __DATE__, __TIME__);
 fprintf(stdout, "Code by %s, Application name : %s, Make in %s\n\n", "JaeHyuk Cho", "MZ test code", "KOREA");
#endif
 if(s_Argc > 1)
 {
  int s_Index, s_Handle, s_ReadBytes, s_TotalLine;
  unsigned char s_Buffer[ 32 << 10 ]; 
  t_MZ_Parser *s_Parser = (t_MZ_Parser *)0;
  s_TotalLine = 0;
  for(s_Index = 1;s_Index < s_Argc;s_Index++)
  {
   s_Handle = open(s_Argv[s_Index], O_RDONLY);
   if(s_Handle >= 0)
   {
    do
    {
     s_ReadBytes = read(s_Handle, &s_Buffer[0], sizeof(s_Buffer));
     if(s_ReadBytes > 0)s_Parser = MZ_Parser_Line(s_Parser, &s_Buffer[0], s_ReadBytes);
    }while(s_ReadBytes == sizeof(s_Buffer));
    s_Parser = MZ_Parser_Line(s_Parser, (void *)0, 0);
    close(s_Handle);
    if(s_Parser)
    {
#if 1 
     t_MZ_Node_Pointer *s_Line;
     int s_LineCount = 1, s_MaxLineValue, s_TempValue;
     s_TempValue = s_Parser->LineCount;
     s_MaxLineValue = 0;
     do
     { 
      s_TempValue /= 10;
      s_MaxLineValue++;
     }while(s_TempValue > 0);
     s_Line = s_Parser->Line;
     while(s_Line)
     {
      fprintf(stdout, "%*d> %s\n", s_MaxLineValue, s_LineCount++, s_Line->Pointer ? (char *)s_Line->Pointer : "");
      s_Line = s_Line->Next;
     }
#endif
     s_TotalLine += s_Parser->LineCount;
     fprintf(stdout, "--------------------------------------------------\n \"%s\" Total line = %d\n", s_Argv[s_Index], s_Parser->LineCount);
     s_Parser = MZ_DestroyParser(s_Parser);
    }
   }
  }
  fprintf(stdout, "===> %d\n", s_TotalLine);
 }
 else
 {
  t_MZ_NetworkInfo *s_NetworkInfo = (t_MZ_NetworkInfo *)0;
  t_MZ_NetworkRoute *s_Route;
  t_MZ_NetworkInterface *s_Interface;
  s_NetworkInfo = MZ_GetNetworkInfo(s_NetworkInfo);
  if(s_NetworkInfo)
  {
   if(s_NetworkInfo->Route)
   {
    s_Route = s_NetworkInfo->Route;
    while(s_Route)
    {
     if(s_Route->Name)
     {
      fprintf(stdout, "Route: [%s]\n", s_Route->Name);
      fprintf(stdout, "\t%s\n", s_Route->Destination);
      fprintf(stdout, "\t%s\n", s_Route->Gateway);
      fprintf(stdout, "\t%s\n", s_Route->Mask);
     }
     else fprintf(stdout, "Route: [NULL]\n");
     s_Route = s_Route->Next;
    }
   }
   if(s_NetworkInfo->Interface)
   {
    s_Interface = s_NetworkInfo->Interface;
    while(s_Interface)
    {
     if(s_Interface->Name)
     {
      fprintf(stdout, "%s: MAC(%s)\n", s_Interface->Name, s_Interface->MAC);
      fprintf(stdout, "\tIP:%s\n", s_Interface->IP);
      fprintf(stdout, "\tBroadcast:%s\n", s_Interface->Broadcast);
      fprintf(stdout, "\tNetmask:%s\n", s_Interface->Netmask);
      fprintf(stdout, "\tFlags:0x%08x\n", s_Interface->Flags);
      fprintf(stdout, "\tMTU:%d\n", s_Interface->MTU);
      fprintf(stdout, "\tMetric:%d\n", s_Interface->Metric);
     }
     else fprintf(stdout, "NULL:\n");
     s_Interface = s_Interface->Next;
    }
   }
   else fprintf(stderr, "Can not interface scan !\n");
   s_NetworkInfo = MZ_DestroyNetworkInfo(s_NetworkInfo);
  }
  
 }

 fprintf(stdout, "\nEnd of test. (%d/%d)\n", MZ_AllocSize(), MZ_AllocCount());
 
 return(s_Return);
}

#endif

/* End of source */
