/*
 Copyright (c) 2002 Information Equipment co.,LTD.
 All Right Reserved.

 Code by JaeHyuk Cho <minzkn@infoeq.co.kr>
*/

#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>

size_t g_Malloc_Count = (size_t)0, g_Malloc_Size  = (size_t)0;

static void (*__MZ_free_hook) __MALLOC_PMT ((__malloc_ptr_t __ptr, __const __malloc_ptr_t));
static __malloc_ptr_t (*__MZ_malloc_hook) __MALLOC_PMT ((size_t __size, __const __malloc_ptr_t));

static void *_MZ_MALLOC_HOOK_(size_t s_Size, const void *s_Caller)
{
 if(s_Size > 0)
 {
  register void *s_Return;
  __malloc_hook = __MZ_malloc_hook, s_Return = (void *)malloc(s_Size + sizeof(size_t)), __malloc_hook = _MZ_MALLOC_HOOK_;	 
  if(s_Return)
  {
   *(((size_t *)s_Return)++) = s_Size;
   g_Malloc_Count++, g_Malloc_Size += s_Size;
   return(s_Return);
  }
 }
 return((void *)0);
}

static void _MZ_FREE_HOOK_(void *s_Ptr, const void *s_Caller)
{
 if(s_Ptr)
 {
  g_Malloc_Count--, g_Malloc_Size -= *(--((size_t *)s_Ptr));
  __free_hook = __MZ_free_hook, free(s_Ptr), __free_hook = _MZ_FREE_HOOK_;
 }
}

void MZ_MALLOC_HOOK(void)
{
 fprintf(stdout, "Memory allocation hook install (Code by JaeHyuk Cho).\n");
 __MZ_malloc_hook = __malloc_hook, __malloc_hook    = _MZ_MALLOC_HOOK_; 
 __MZ_free_hook   = __free_hook  , __free_hook      = _MZ_FREE_HOOK_;
}

/* End of source */ 
