/* 
  Copyright (c) 2004 JaeHyuk Cho <mailto:minzkn@infoeq.com>
  All right reserved.
*/

DEF_DESCRIPTOR_NULL   = 0x0000
DEF_DESCRIPTOR_CODE32 = 0x0008
DEF_DESCRIPTOR_DATA32 = 0x0010

.extern main

.code16
.org 0
L_Entry:
	cli

	movw %cs, %ax
	movw %ax, %ds

	xorl %eax, %eax
	movw %ds, %ax
	shll $4, %eax
	addl $L_GDT, %eax
	movl %eax, (L_GDTR + 2)

	xorl %eax, %eax
	movw %cs, %ax
	shll $4, %eax
	addl $L_Code32_Entry, %eax
	movl %eax, (L_JumpAdjust32)

	lidt L_IDTR /* fword ptr */
	lgdt L_GDTR /* fword ptr */
	movl %cr0, %eax
	orb $0x01, %al
	movl %eax, %cr0
	jmp 0f
0:	

	.byte 0x66 /* 32bit prefix */
	.byte 0xea /* SEG16:OFF32 long jump */
L_JumpAdjust32:
	.long 0x00000000
	.word DEF_DESCRIPTOR_CODE32

L_GDT:
	/* GDT 0x0000 (Null) */ 
	.word 0x0000
	.word 0x0000
	.word 0x0000
	.word 0x0000
	/* GDT 0x0008 (Code 32) */
	.word 0xffff
	.word 0x0000
	.word 0x9a00
	.word 0x00cf
	/* GDT 0x0010 (Data 32) */
	.word 0xffff
	.word 0x0000
	.word 0x9200
	.word 0x00cf
L_EndGDT:
L_GDTR: /* GDT register (Limit:WORD, Offset:DWORD) */
	.word L_EndGDT - L_GDT - 1
	.long 0x00000000
	.word 0x0000 /* Not used (Alignment) */
L_IDTR: /* IDT register (Limit:WORD, Offset:DWORD */
	.word 0x0000
	.long 0x00000000
	.word 0x0000 /* Not used (Alignment) */

.include "print.s"
.include "keyboard.s"
.include "disk.s"
.include "error.s"

.code32
L_Code32_Entry:
	movw $DEF_DESCRIPTOR_DATA32, %ax
	movw %ax, %ds
	movw %ax, %es
	movw %ax, %ss
	movw %ax, %fs
	movw %ax, %gs
	movl $0x10000, %esp
	movl %esp, %ebp

	/* Memory remap */

	call main
	cli
	hlt
	jmp .

.global L_Entry
.end

/* End of source */
