/* 
  Copyright (c) 2004 JaeHyuk Cho <mailto:minzkn@infoeq.com>
  All right reserved.
*/

/*
  Floppy boot sector
*/

/* copy.s value */
DEF_BOOT_SEG       =0x07c0
DEF_SECTOR_SIZE    =512
DEF_COPY_SEG_BOOT  =0x0080

DEF_KERNEL_SEG     =0x0800
DEF_IMAGE_SIZE     =(65536)

.code16
.org 0
L_Entry:
.include "copy.s"

	movw $L_Message_00, %si
	callw P_Print

	xorb %al, %al
	movb %al, (L_Drive)
	callw P_ResetDisk
	callw P_GetDiskParameters

	movw $DEF_KERNEL_SEG, %ax
	movw %ax, %es
	xorw %bx, %bx
	xorw %dx, %dx
	movw $0x0001, %ax
	movw $(DEF_IMAGE_SIZE / DEF_SECTOR_SIZE), %cx
0:
	pushw %dx
	pushw %cx
	pushw %ax
	pushw %bx

	pushw %ax
	callw P_LBA_ReadSector
	popw %ax

	.if 1
	callw P_PrintDigit
	movb $'/', %al
	callw P_Putc
	movw $(DEF_IMAGE_SIZE / DEF_SECTOR_SIZE), %ax
	callw P_PrintDigit
	movw $L_Message_02, %si
	callw P_Print
	.endif
	
	popw %bx
	popw %ax
	popw %cx
	popw %dx
	addw $0x0001, %ax
	adcw $0x0000, %dx
	addw $DEF_SECTOR_SIZE, %bx
	loop 0b
	
	callw P_ResetDisk
	
	movw $L_Message_01, %si
	callw P_Print

	jmpl $DEF_KERNEL_SEG, $0x0000

L_Message_00:
	.string "\r\nLoading kernel image. . .\r\n"
L_Message_01:
	.string "Jumping.\r\n"
L_Message_02:
	.string " read sector.\r\n"

.include "print.s"
.include "keyboard.s"
.include "disk.s"
.include "error.s"

.org DEF_SECTOR_SIZE - 2
	.word 0xaa55

.global L_Entry
.end

/* End of source */
